import { ConfigLoader as CLD } from "./lib/config-loader";
import { EventsProcess as EP } from "./lib/events-process";
import { AgentConfig as CFG } from "./lib/config";
import { BackendProxy as BP } from "./lib/http/backend-proxy";
import { AgentEventsController as AEC } from "./lib/agent-events/agent-events-controller";
import { AgentType as AT, Technology as TEC } from "./lib/agent-events/agent-events-conracts";
import { EventTypes as ET, IEvent as IEVT } from "./lib/events-process/events-contracts";
import { ValidationUtils as VU } from "./lib/utils/validation-utils";
import { EventsCreator as EC } from "./lib/events-process/events-creator";
import { HttpClientConfigData as HCCD, IHttpClient as IHC } from "./lib/http/contracts";
import { AgentDataService as ADS } from "./lib/agent-data-service";
import { IWatchdog as IWD } from "./lib/watchdog";
import { IQueue as IQ } from "./lib/queue";
import { getSystemDateValueOf as GSD } from "./lib/system-date";
export declare namespace SlJsInfra {
    type ConfigLoader = CLD;
    const ConfigLoader: typeof CLD;
    type EventsProcess = EP;
    const EventsProcess: typeof EP;
    type AgentConfig = CFG;
    const AgentConfig: typeof CFG;
    type BackendProxy = BP;
    const BackendProxy: typeof BP;
    type AgentEventsController = AEC;
    const AgentEventsController: typeof AEC;
    type EventsCreator = EC;
    const EventsCreator: typeof EC;
    type AgentDataService = ADS;
    const AgentDataService: typeof ADS;
    const getSystemDateValueOf: typeof GSD;
    namespace Entities {
        type IHttpClient = IHC;
        type IEvent = IEVT;
        type IWatchdog = IWD;
        type IQueue = IQ<any>;
        type AgentType = AT;
        const AgentType: typeof AT;
        type Technology = TEC;
        const Technology: typeof TEC;
        type EventTypes = ET;
        const EventTypes: typeof ET;
        type HttpClientConfigData = HCCD;
        const HttpClientConfigData: typeof HCCD;
    }
    namespace Utils {
        type ValidationUtils = VU;
        const ValidationUtils: typeof VU;
    }
}
