"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var http_client_1 = require("./lib/http/http-client");
var backend_proxy_1 = require("./lib/http/backend-proxy");
var contracts_1 = require("./lib/http/contracts");
var messages_formatter_1 = require("./lib/messages-formatter");
var sl_env_vars_1 = require("./lib/constants/sl-env-vars");
var footprints_process_1 = require("./lib/footprints-process");
var istanbul_to_footprints_1 = require("./lib/footprints-process/istanbul-to-footprints");
var watchdog_1 = require("./lib/watchdog");
var watchdog_2 = require("./lib/watchdog");
var footprints_service_proxy_1 = require("./lib/footprints-process/footprints-service-proxy");
var environment_data_service_1 = require("./lib/environment-data-service");
var config_1 = require("./lib/config");
var config_loader_1 = require("./lib/config-loader");
var istanbul_to_footprints_contract_1 = require("./lib/footprints-process/istanbul-to-footprints-contract");
var agent_data_service_1 = require("./lib/agent-data-service");
var validation_utils_1 = require("./lib/utils/validation-utils");
var ignored_files_handler_1 = require("./lib/ignored-files-handler");
var production_footprints_handler_1 = require("./lib/footprints-process/production-footprints-handler");
var contracts_2 = require("./lib/http/contracts");
var unique_id_converter_1 = require("./lib/coverage-elements/unique-id-converter");
var short_name_to_file_mapper_1 = require("./lib/short-name-to-file-mapper");
var queue_1 = require("./lib/queue");
var events_process_1 = require("./lib/events-process");
var events_creator_1 = require("./lib/events-process/events-creator");
var events_contracts_1 = require("./lib/events-process/events-contracts");
var source_map_reader_1 = require("./lib/source-map-reader");
var source_map_handler_1 = require("./lib/source-map-handler");
var agent_events_controller_1 = require("./lib/agent-events/agent-events-controller");
var files_utils_1 = require("./lib/utils/files-utils");
var agent_events_conracts_1 = require("./lib/agent-events/agent-events-conracts");
var mock_server_proxy_1 = require("./lib/utils/test-utils/mock-server-utils/mock-server-proxy");
var system_date_1 = require("./lib/system-date");
var SlJsInfra;
(function (SlJsInfra) {
    SlJsInfra.Watchdog = watchdog_1.Watchdog;
    SlJsInfra.HttpClient = http_client_1.HttpClient;
    SlJsInfra.BackendProxy = backend_proxy_1.BackendProxy;
    SlJsInfra.AgentConfig = config_1.AgentConfig;
    SlJsInfra.ConfigLoader = config_loader_1.ConfigLoader;
    SlJsInfra.MessageFormatter = messages_formatter_1.MessagesFormatter;
    SlJsInfra.SlEnvVars = sl_env_vars_1.SlEnvVars;
    SlJsInfra.FootprintsProcess = footprints_process_1.FootprintsProcess;
    SlJsInfra.FootprintsProxy = footprints_service_proxy_1.FootprintsServiceProxy;
    SlJsInfra.ProductionFootprintsHandler = production_footprints_handler_1.ProductionFootprintsHandler;
    SlJsInfra.IstanbulToFootprints = istanbul_to_footprints_1.IstanbulToFootprints;
    SlJsInfra.EnvironmentDataService = environment_data_service_1.EnvironmentDataService;
    SlJsInfra.AgentDataService = agent_data_service_1.AgentDataService;
    SlJsInfra.IgnoredFilesHandler = ignored_files_handler_1.IgnoredFilesHandler;
    SlJsInfra.UniqueIdConverter = unique_id_converter_1.UniqueIdConverter;
    SlJsInfra.ShortNameToFileMapper = short_name_to_file_mapper_1.ShortNameToFileMapper;
    SlJsInfra.EventsProcess = events_process_1.EventsProcess;
    SlJsInfra.EventsCreator = events_creator_1.EventsCreator;
    SlJsInfra.SourceMapReader = source_map_reader_1.SourceMapReader;
    SlJsInfra.AgentEventsController = agent_events_controller_1.AgentEventsController;
    SlJsInfra.Queue = queue_1.Queue;
    SlJsInfra.SourceMapHandler = source_map_handler_1.SourceMapHandler;
    SlJsInfra.getSystemDateValueOf = system_date_1.getSystemDateValueOf;
    var Utils;
    (function (Utils) {
        Utils.ValidationUtils = validation_utils_1.ValidationUtils;
        Utils.FileUtils = files_utils_1.FilesUtils;
    })(Utils = SlJsInfra.Utils || (SlJsInfra.Utils = {}));
    var TestUtils;
    (function (TestUtils) {
        TestUtils.MockServerProxy = mock_server_proxy_1.MockServerProxy;
    })(TestUtils = SlJsInfra.TestUtils || (SlJsInfra.TestUtils = {}));
    var Entities;
    (function (Entities) {
        Entities.CreateBuildSessionIdResponse = contracts_1.CreateBuildSessionIdResponse;
        Entities.HttpClientConfigData = contracts_1.HttpClientConfigData;
        Entities.GetVersionRequest = contracts_1.GetVersionRequest;
        Entities.WatchdogOptions = watchdog_2.WatchdogOptions;
        Entities.IExtendedIstanbulMetrics = istanbul_to_footprints_contract_1.IExtendedIstanbulMetrics;
        Entities.StartExecutionRequest = contracts_2.StartExecutionRequest;
        Entities.EndExecutionRequest = contracts_2.EndExecutionRequest;
        Entities.UploadReportRequest = contracts_2.UploadReportRequest;
        Entities.AgentData = contracts_2.AgentData;
        Entities.UploadReportsBody = contracts_2.UploadReportsBody;
        Entities.EventTypes = events_contracts_1.EventTypes;
        Entities.AgentType = agent_events_conracts_1.AgentType;
        Entities.Technology = agent_events_conracts_1.Technology;
        Entities.AgentEventCode = agent_events_conracts_1.AgentEventCode;
        Entities.RecommendationSetStatus = contracts_1.RecommendationSetStatus;
        Entities.TestSelectionStatus = events_contracts_1.TestSelectionStatus;
    })(Entities = SlJsInfra.Entities || (SlJsInfra.Entities = {}));
})(SlJsInfra = exports.SlJsInfra || (exports.SlJsInfra = {}));
//# sourceMappingURL=index.js.map