import { AgentConfig } from "../config";
import { AgentType, IAgentEvent, IAgentStartInfo, IPingData, ITagInfo, IToolInfo, Technology } from "./agent-events-conracts";
import { BackendProxy } from "../http/backend-proxy";
import { Watchdog } from "../watchdog";
import bunyan = require('bunyan');
export declare class AgentEventsController {
    private static readonly PING_INTERVAL;
    private static readonly MAX_SHUTDOWN_RETRIES;
    private _agentConfig;
    private _type;
    private _agentId;
    private backendProxy;
    private _logger;
    private _technology;
    private _sendsPing;
    private _watchdog;
    private _tools;
    private startRequestStatus;
    private shutDownRetries;
    constructor(agentConfig: AgentConfig, agentType: AgentType, technology: Technology, sendsPing: boolean, logger: bunyan, backendProxy?: BackendProxy);
    submitAgentStartedEvent(packageJsonFile?: any): Promise<void>;
    private submitAgentEventRequest;
    buildAgentStartEvent(packageJsonFile: any): IAgentEvent<IAgentStartInfo>;
    buildAgentShutdownEvent(): IAgentEvent<IPingData>;
    submitAgentShutdownEvent(): Promise<boolean>;
    submitPingEvent(): void;
    submitMessage(message: string): void;
    readonly watchdog: Watchdog;
    readonly agentConfig: AgentConfig;
    readonly type: AgentType;
    readonly logger: bunyan;
    readonly technology: Technology;
    readonly sendsPing: boolean;
    readonly tools: IToolInfo[];
    resolveTags(): ITagInfo[];
    addTool(tollInfo: IToolInfo): void;
    private createBackendProxy;
    private initWatchdog;
    private getTimers;
    private buildEvent;
    readonly agentId: string;
}
