import { IWatchdog } from "../watchdog";
import { IQueue } from "../queue";
import { BackendProxy } from "../http/backend-proxy";
import { IEnvironment, IEvent, IEventsFile, TestSelectionStatus } from "./events-contracts";
import { AgentConfig } from "../config";
import { AgentEventsController } from "../agent-events/agent-events-controller";
export declare class EventsProcess {
    protected static readonly ITEMS_TO_DEQUE = 1000;
    private _configuration;
    private keepAliveWatchdog;
    private _sendToServerWatchdog;
    private environmentData;
    private agentEventsController;
    private _backendProxy;
    private _eventsQueue;
    private _logger;
    private _isRunning;
    private sequence;
    private _onGoingRequests;
    private _testSelectionStatus;
    constructor(configuration: AgentConfig, sendToServerWatchdog: IWatchdog, keepAliveWatchdog: IWatchdog, environmentDataService: IEnvironment, agentEventsController: AgentEventsController, backendProxy: BackendProxy, eventsQueue: IQueue<IEvent>, logger: any);
    enqueueEvent(evt: IEvent): void;
    start(): void;
    stop(): Promise<void>;
    getQueueSize(): any;
    private submitEvents;
    private submitEventsSync;
    protected createEventsPacket(items: any[]): IEventsFile;
    private init;
    private ensureKeepaliveThreadRunning;
    private removeRequest;
    readonly onGoingRequests: Promise<any>[];
    readonly configuration: AgentConfig;
    readonly logger: any;
    isRunning: boolean;
    readonly sendToServerWatchdog: IWatchdog;
    readonly backendProxy: BackendProxy;
    readonly eventsQueue: IQueue<IEvent>;
    testSelectionStatus: TestSelectionStatus;
}
