"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var system_date_1 = require("../system-date");
var CollectionInterval = /** @class */ (function () {
    function CollectionInterval(intervalInMS) {
        this.intervalInSeconds = this.toSeconds(intervalInMS);
        this.start = this.toSeconds(system_date_1.getSystemDateValueOf());
    }
    CollectionInterval.prototype.next = function () {
        if (this.end) {
            this.start = this.end;
        }
        this.end = this.toSeconds(system_date_1.getSystemDateValueOf());
        if ((this.end - this.start) > this.intervalInSeconds) {
            this.start = this.end - this.intervalInSeconds;
        }
    };
    CollectionInterval.prototype.toJson = function () {
        return { start: this.start, end: this.end };
    };
    CollectionInterval.prototype.toSeconds = function (time) {
        return Math.floor(time / 1000);
    };
    return CollectionInterval;
}());
exports.CollectionInterval = CollectionInterval;
//# sourceMappingURL=collection-interval.js.map